note
	description: "A database which uses binary search but does not keep a sorted array."
	author: "Jackie Wang"
	date: "$Date$"
	revision: "$Revision$"

class
	DATABASE_V1

inherit
	DATABASE

create
	make

feature -- Constructor

	make
			-- Create an empty database.
		do
			create data.make_empty
		end

	add_name (n: STRING)
			-- Add `n` to database. 
		do
			-- Inappropriate implementation: insert to the end
			-- This results in an unsorted array for the binary search.
			data.force (n, data.count + 1)
		end

	data_exists (n: STRING): BOOLEAN
		local
			u: UTILITIES_V1
		do
			create u
			-- Input to binary search might be invalid: `data` array is not kept sorted, but a binary search is called.
			-- However, {UTILITIES}.search does not require a sorted array as the input.
			Result := u.search (data, n)
		end
end
