note
	description: "A correct binary search implementation without an explicit precondition of the input array being sorted."
	author: "Jackie Wang"
	date: "$Date$"
	revision: "$Revision$"

class
	UTILITIES_V1

create
	default_create

feature -- Binary Search

	search (a: ARRAY[STRING]; a_name: STRING): BOOLEAN
		do
			Result := search_helper (a, a.lower, a.upper, a_name)
		end

feature {NONE} -- Recursive Helper

	search_helper (a: ARRAY[STRING]; left: INTEGER; right: INTEGER; a_name: STRING): BOOLEAN
		local
			mid: INTEGER
		do
			if left > right then
				Result := False
			elseif left = right then
				if a[left] ~ a_name then
					Result := True
				else
					Result := False
				end
			else
				mid := (left + right) // 2
				if a_name > a[mid] then
					Result := search_helper (a, mid + 1, right, a_name)
				elseif a_name < a[mid] then
					Result := search_helper (a, left, mid - 1, a_name)
				else
					Result := True
				end
			end
		end

end
