note
	description: "A database which uses binary search and keeps a sorted array."
	author: "Jackie Wang"
	date: "$Date$"
	revision: "$Revision$"

class
	DATABASE_V3

inherit
	DATABASE

create
	make

feature -- Constructor

	make
			-- Create an empty database.
		do
			create data.make_empty
		end

	add_name (n: STRING)
			-- Add `n` to database.
		local
			i: INTEGER
			new_data: ARRAY[STRING]
			done: BOOLEAN
		do
			-- Appropriate implementation: insert to the place so that data remains sorteds
			from
				create new_data.make_filled ("", data.lower, data.upper + 1)
				i := data.lower
			until
				done or i > data.upper
			loop
				if data[i] > n then
					new_data[i] := n
					done := true
				else
					new_data[i] := data[i]
				end
				i := i + 1
			end

			if done then
				from
				until
					i > new_data.upper
				loop
					new_data[i] := data[i - 1]
					i := i + 1
				end
			else
				check i = data.count + 1 end
				new_data[i] := n
			end
			data := new_data
		end

	data_exists (n: STRING): BOOLEAN
		local
			u: UTILITIES_V3
		do
			create u
			-- Input to binary search is always valid: `data` array is kept sorted.
			-- {UTILITIES}.search requires a sorted array as the input,
			-- but DATABASE_V3 will never be blamed because no precondition violation will occur.
			Result := u.search (data, n)
		end
end
